﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace PhoneAppAnimation
{
    // Example illustrating animation on Windows Phone
    public partial class MainPage : PhoneApplicationPage
    {
        // Random number generator
        private Random random = new Random();

        // Offset point of the touch contact
        private Point offset = new Point();


        // Constructor
        public MainPage()
        {
            InitializeComponent();

            // Disable the frame rate counter (tiny numbers on the right side of the screen)
            Application.Current.Host.Settings.EnableFrameRateCounter = false;

            // Pick a elastic easing function
            ElasticEase elasticEase = new ElasticEase();
            elasticEase.Springiness = 5;
            elasticEase.Oscillations = 3;
            this.animationX.EasingFunction = elasticEase;
            this.animationY.EasingFunction = elasticEase;
        }


        private void rectangle_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            // Save the offset of the touch point relative to the
            // upper left corner of the rectangle
            this.offset = e.GetPosition(this.rectangle);
        }

        private void rectangle_MouseMove(object sender, MouseEventArgs e)
        {
            // Set the current touch point of the finger as the new location for 
            // the rectangle (minus the offset)
            this.rectangle.SetValue(Canvas.LeftProperty, (double)(e.GetPosition(null).X - this.offset.X));
            this.rectangle.SetValue(Canvas.TopProperty, (double)(e.GetPosition(null).Y - this.offset.Y));
        }


        private void rectangle_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            // When releasing the touch, the rectangle is supposed
            // to bounce back to its location in the center of the screen
            double newPositionX = this.canvas.ActualWidth / 2 - this.rectangle.ActualWidth / 2;
            double newPositionY = this.canvas.ActualHeight / 2 - this.rectangle.ActualHeight / 2;

            // Use the animation object we defined in XAML,
            // and set the new target position
            this.animationX.From = (double)this.rectangle.GetValue(Canvas.LeftProperty);
            this.animationX.To = newPositionX;
            this.animationY.From = (double)this.rectangle.GetValue(Canvas.TopProperty);
            this.animationY.To = newPositionY;

            // Start the storyboard
            this.storyboard.Begin();
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {

            // Hide the status bar on top of the screen
            SystemTray.IsVisible = false;
        }


    }
}